'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = convert;

var _canvg = require('canvg');

var _canvg2 = _interopRequireDefault(_canvg);

var _gcanvas = require('gcanvas');

var _gcanvas2 = _interopRequireDefault(_gcanvas);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _gcanvasLaserDriver = require('./gcanvas-laser-driver');

var _gcanvasLaserDriver2 = _interopRequireDefault(_gcanvasLaserDriver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import {parseString} from 'gcode-parser'

// import gcanvas from '../../gcanvas'
var parser = require('gcode-parser');
// console.log(parseString);
// process.exit();
var laserDriver = new _gcanvasLaserDriver2.default();

// var gctx = new gcanvas()
var gctx = new _gcanvas2.default(laserDriver);

function preamble(input, options) {
  var feedRate = options.feed || 3000;
  return 'G21\n F' + feedRate + '\n';
}

function postamble(input, options) {
  return 'G0 X0 Y0';
}

gctx.fill = function (windingRule, depth) {
  gctx.save();
  gctx.strokeStyle = gctx.fillStyle;
  gctx.stroke('outer', depth);
  gctx.restore();
};

//Mirrored Y in gcanvas workaround
gctx.map('x-yz');

// let minimum = 0
// gctx.filter(function(p) {
//   // flip_y_moves
//   // console.log(p.y);
//   if(p.y < minimum){
//     minimum = p.y
//   }
//   console.log(p.y);
// });

// gctx.filter(function(p) {
//   console.log('Min:',minimum);
// });

// Correctly mirror in positive y-axis
// let minimum = getMinumum(doc)
// doc.filter(function(p) {
//   // flip_y_moves
//   p.y = -p.y
//rerange_y
//   y = y - minimum
// });

// function mirror(gcode){
//   parseString(gcode, function(err, results) {
//   console.log(gcode.length);
//       if (err) {
//           console.error(err);
//           return;
//       }

//       // Compose G-code
//       var list = results
//           .map('words')
//           .map(function(words) {
//               return words.map(function(word) {
//                   return word[0] + word[1];
//               }).join(' ');
//           })

//       console.log(list);
//   })
// }

function convert(input, options, callback) {
  gctx.toolDiameter = options.toolDiameter || 0.15;
  var svg = '' + _fs2.default.readFileSync(input);
  (0, _canvg2.default)(gctx.canvas, svg);
  // console.log(minimum);
  var doc = gctx.driver.getDoc();

  // let test = parser.parseString('G0 X1',{},function(err, results) {
  //   console.log(results);
  // })
  //.on('data', function(data) {
  //   console.log(data);
  // })
  // .on('progress', function(o) {
  //     console.log(o.current, o.total);
  // })
  // .on('end', function(results) {
  //     console.log(results);
  // })
  // console.log(test);
  doc.prepend(preamble(input, options)).append(postamble(input, options));

  callback(null, doc);
  // process.exit();
}