'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = convert;

var _raster = require('./converters/raster');

var _raster2 = _interopRequireDefault(_raster);

var _vector = require('./converters/vector');

var _vector2 = _interopRequireDefault(_vector);

var _fileExtension = require('file-extension');

var _fileExtension2 = _interopRequireDefault(_fileExtension);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function convert(input, options, callback) {
  var fileType = options.fileType || (0, _fileExtension2.default)(input);

  switch (fileType) {
    //Raster
    case 'raster':
    case 'png':
    case 'jpg':
    case 'jpeg':
    case 'gif':
      (0, _raster2.default)(input, options, callback);
      break;
    //Vector
    case 'vector':
    case 'svg':
    case 'dxf':
    case 'stl':
      (0, _vector2.default)(input, options, callback);
      break;
    default:
      console.log('Unsupported file type:', fileType);
  }
}